﻿using System;
using TrioMotion.TrioPC_NET;

namespace TrioPCMotion
{
    internal class Program
    {
        static void Main(string[] args)
        {
            // Create an instance of MyController
            MyController myController = new MyController();
            myController.ConnectToController("192.168.0.241");

            // Get initial VR index to display
            Console.WriteLine("Enter VR start index: ");
            int startVR = Convert.ToInt32(Console.ReadLine());

            // Get total VR index to display
            Console.WriteLine("Enter total VRs to fetch");
            int totalVR = Convert.ToInt32(Console.ReadLine());

            myController.displayVRs(startVR, totalVR);

            myController.tripleVRs(startVR, totalVR);

            myController.displayVRs(startVR, totalVR);

            Console.ReadLine();
        }
    }
    internal class MyController : TrioPC
    {
        internal void tripleVRs(int startingIndex, int number)
        {
            double temp;

            Console.WriteLine("Initialising VRs to tripple the original values ...");

            if (this.IsOpen(PortId.EthernetREMOTE))
            {
                for (int index = 0; index < number; index++)
                {
                    this.GetVr((index + startingIndex), out temp);

                    temp = 3 * temp;

                    this.SetVr((index + startingIndex), temp);
                }
            }
            else
            {
                Console.WriteLine("Not connected to controller");
            }
        }

        internal void ConnectToController(string ip_address)
        {
            this.SetHost(ip_address);

            if (this.Open(PortType.Ethernet, PortId.EthernetREMOTE))
            {
                Console.WriteLine("Connected to contoller on ip: {0}", this.HostAddress);
            }
            else
            {
                Console.WriteLine("Error in connecting to ip: {0}", this.HostAddress);
            }
        }

        internal void displayVRs(int startingIndex, int number)
        {
            double temp;

            Console.WriteLine("Reading VRs:");

            if (this.IsOpen(PortId.EthernetREMOTE))
            {
                for (int index = 0; index < number; index++)
                {
                    if (this.GetVr((index + startingIndex), out temp))
                    {
                        Console.WriteLine("VR({0}) = {1}", (index + startingIndex), temp);
                    }
                }
            }
            else
            {
                Console.WriteLine("Not connected to controller");
            }
        }
    }
}
